//+------------------------------------------------------------------+
//|                                                              rsx |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum -5
#property indicator_maximum 105
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int    Length                  = 7;
extern int    Price                   = PRICE_CLOSE;
extern double Damping                 =  5;
extern double Noise                   = 30;
extern bool   UseTimMorrisAvg         = true;
extern double levelUp                 = 100;
extern double levelDown               =   0;
extern double levelUp1                =  80;
extern double levelDown1              =  20;
extern bool   arrowsVisible           = false;
extern string arrowsUniqueID          = "RsiTMArrows";
extern color  arrowsUpColor           = DeepSkyBlue;
extern color  arrowsDnColor           = PaleVioletRed;
extern bool   arrowsOnEveryLevelCross = true;
extern bool   arrowsOnCross           = true;
extern bool   arrowsOnRevert          = false;
extern int    arrowsUpCode            = 241;
extern int    arrowsDownCode          = 242;
extern bool   alertsOn                = false;
extern bool   alertsOnEveryLevelCross = true;
extern bool   alertsOnCross           = true;
extern bool   alertsOnRevert          = false;
extern bool   alertsOnCurrent         = false;
extern bool   alertsMessage           = true;
extern bool   alertsSound             = false;
extern bool   alertsEmail             = false;

//
//
//
//
//

double rsx[];
double rsxDa[];
double rsxDb[];
double slope[];
double trenda[];
double trends[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,rsx);   SetIndexLabel(0,"Rsi");
   SetIndexBuffer(1,rsxDa); SetIndexLabel(1,"Rsi");
   SetIndexBuffer(2,rsxDb); SetIndexLabel(2,"Rsi");
   SetIndexBuffer(3,slope);
   SetIndexBuffer(4,trenda);
   SetIndexBuffer(5,trends);
      if (UseTimMorrisAvg)
            string add = "Tim Morris smoothed";
      else         add = "Jurik smoothed";
   IndicatorShortName("Rsi "+add+" ("+Length+")");
   SetLevelValue(0,levelUp);
   SetLevelValue(1,levelDown);
   SetLevelValue(2,levelUp1);
   SetLevelValue(3,levelDown1);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsUniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}



//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrkBuffer[][3];

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);

   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,rsxDa,rsxDb);
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][0] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      wrkBuffer[r][1] = iWAverage(0.5*(MathAbs(wrkBuffer[r][0]-wrkBuffer[r-1][0])+(wrkBuffer[r][0]-wrkBuffer[r-1][0])),0.5*(Length-1),i,0);
      wrkBuffer[r][2] = iWAverage(0.5*(MathAbs(wrkBuffer[r][0]-wrkBuffer[r-1][0])-(wrkBuffer[r][0]-wrkBuffer[r-1][0])),0.5*(Length-1),i,1);

      //
      //
      //
      //
      //
      
      if (UseTimMorrisAvg)
      {
         if((wrkBuffer[r][1] + wrkBuffer[r][2]) != 0) 
               rsx[i] = MathMin(MathMax(iTmSmooth(100 * wrkBuffer[r][1]/(wrkBuffer[r][1] + wrkBuffer[r][2]),Damping,Noise,Length,i),0),100);
         else  rsx[i] = MathMin(MathMax(iTmSmooth(50                                                       ,Damping,Noise,Length,i),0),100);
      }
      else
      {
         if((wrkBuffer[r][1] + wrkBuffer[r][2]) != 0) 
               rsx[i] = iSmooth(100 * wrkBuffer[r][1]/(wrkBuffer[r][1] + wrkBuffer[r][2]),Length,0,i);
         else  rsx[i] = iSmooth(50                                                       ,Length,0,i);
      }
      rsxDa[i] = EMPTY_VALUE;
      rsxDb[i] = EMPTY_VALUE;
      slope[i] = slope[i+1];
         if (rsx[i] > rsx[i+1]) slope[i] =  1;
         if (rsx[i] < rsx[i+1]) slope[i] = -1;
         if (slope[i] == -1) PlotPoint(i,rsxDa,rsxDb,rsx);
         
      //
      //
      //
      //
      //
      
      if (arrowsOnEveryLevelCross)
            trenda[i] = 0;
      else  trenda[i] = trenda[i+1];
      if (alertsOnEveryLevelCross)
            trends[i] = 0;
      else  trends[i] = trenda[i+1];
      if (rsx[i] >= levelUp)   { trenda[i] =  1; trends[i] =  1; }
      if (rsx[i] <= levelDown) { trenda[i] = -1; trends[i] = -1; }
      manageArrow(i);
   }
   manageAlerts();
   
   //
   //
   //
   //
   //
   
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
         deleteArrow(Time[i]);
         if (trenda[i]!=trenda[i+1])
         {
            if (arrowsOnCross  && trenda[i] == 1)                    drawArrow(i,arrowsUpColor,arrowsUpCode  ,false);
            if (arrowsOnCross  && trenda[i] ==-1)                    drawArrow(i,arrowsDnColor,arrowsDownCode,true);
            if (arrowsOnRevert && trenda[i] == 0 && trenda[i+1]== 1) drawArrow(i,arrowsDnColor,arrowsDownCode,true);
            if (arrowsOnRevert && trenda[i] == 0 && trenda[i+1]==-1) drawArrow(i,arrowsUpColor,arrowsUpCode  ,false);
         }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsUniqueID+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsUniqueID+":"+time; ObjectDelete(lookFor);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trends[whichBar] != trends[whichBar+1])
      {
         if (alertsOnCross  && trends[whichBar] == 1)                           doAlert(whichBar,"up");
         if (alertsOnCross  && trends[whichBar] ==-1)                           doAlert(whichBar,"down");
         if (alertsOnRevert && trends[whichBar] == 0 && trends[whichBar+1]== 1) doAlert(whichBar,"back from up into zone");
         if (alertsOnRevert && trends[whichBar] ==-0 && trends[whichBar+1]==-1) doAlert(whichBar,"back from down into zone");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Rsi TM broke ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"BB macd "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double workWilders[][2];
double iWAverage(double price, double period, int i,int forInstance)
{
   if (ArrayRange(workWilders,0) != Bars) ArrayResize(workWilders,Bars);
 
   int r=Bars-i-1;
      if (r<period)
            workWilders[r][forInstance] = price;
      else  workWilders[r][forInstance] = workWilders[r-1][forInstance]+(price-workWilders[r-1][forInstance])/period;
   return(workWilders[r][forInstance]);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrkTm[][3];
#define _price 0
#define _y1    1
#define _y2    2

//
//
//
//
//

double iTmSmooth(double price, double damping, double noise, double length, int i)
{
   if (ArrayRange(wrkTm,0) != Bars) ArrayResize(wrkTm,Bars);
   if (length<=1) return(price);
      int r = Bars-i-1;

   //
   //
   //
   //
   //

      wrkTm[r][_price] = price;

         double y1 = wrkTm[r-1][_y1];
         double y2 = wrkTm[r-1][_y2];
         
         double err = (wrkTm[r][_price]-2.0*y1+y2)/noise; 
         double drv = MathMax(MathMin((1.0/length)*err*err+(1.0/length)*MathAbs(err),0.5),0.0);
         double dmp = MathMax(MathMin((1.0/length)*MathAbs(y1-y2)/noise + damping/100.0,1.0),0.0);
         
         //
         //
         //
         //
         //
         
      double tmAvg  = y1 + noise*err*drv + (y1-y2)*(1.0-dmp);
      wrkTm[r][_y1] = tmAvg;
      wrkTm[r][_y2] = y1;
      return(tmAvg);
}   



//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}